﻿Public Class FrmECC

    Public MyConfiguration As ECC_LIB.ECC_Configuration_Entry

    Sub New(cfg As ECC_LIB.ECC_Configuration_Entry)

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        Me.MyConfiguration = cfg
    End Sub

    Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        MyConfiguration = New ECC_LIB.ECC_Configuration_Entry
        MyConfiguration.Algorithm = ECC_LIB.ecc_algorithum.bch
        MyConfiguration.Selected = False
        MyConfiguration.ChunkSize = 512
        MyConfiguration.BitError = 4
        MyConfiguration.RsSymSize = 9
        MyConfiguration.ECC_Reverse = False

    End Sub

    Private Sub FrmECC_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        cbAlgorithm.SelectedIndex = MyConfiguration.Algorithm
        lbl_nandecc_algorithm.Text = RM.GetString("nandecc_algorithm") '"Algorithm"
        lbl_nandecc_biterror.Text = RM.GetString("nandecc_biterror") '"Bit-error"
        cb_rs_reverse_data.Text = RM.GetString("nandecc_revbyteorder") '"Reverse byte order"
        lbl_sym_width.Text = RM.GetString("nandecc_symwidth") '"Symbol width"
        txtChunk.Text = MyConfiguration.ChunkSize.ToString()
        txtOffset.Text = MyConfiguration.InitialOffset.ToString()
        txtSpacing.Text = MyConfiguration.Spacing.ToString()
        cb_ECC_BITERR.SelectedIndex = (MyConfiguration.BitError - 1)
        Select Case MyConfiguration.RsSymSize
            Case 9
                cb_sym_width.SelectedIndex = 0
            Case 10
                cb_sym_width.SelectedIndex = 1
            Case Else
                cb_sym_width.SelectedIndex = 1
        End Select
        cb_rs_reverse_data.Checked = MyConfiguration.ECC_Reverse
        cmdOkay.Select()
        cmdOkay.Focus()
    End Sub

    Private Sub txtChunk_LostFocus(sender As Object, e As EventArgs) Handles txtChunk.LostFocus
        Dim alg = CType(cbAlgorithm.SelectedIndex, ECC_LIB.ecc_algorithum)
        If alg = ECC_LIB.ecc_algorithum.dhara OrElse alg = ECC_LIB.ecc_algorithum.hamming Then
            If (CInt(txtChunk.Text) > 512) Then
                txtChunk.Text = CStr(512)
            End If
        End If
    End Sub

    Private Sub cmdCancel_Click(sender As Object, e As EventArgs) Handles cmdCancel.Click
        Me.DialogResult = DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub cmdOkay_Click(sender As Object, e As EventArgs) Handles cmdOkay.Click
        Me.DialogResult = DialogResult.OK
        MyConfiguration.Algorithm = CType(cbAlgorithm.SelectedIndex, ECC_LIB.ecc_algorithum)
        MyConfiguration.ChunkSize = CUShort(txtChunk.Text)
        MyConfiguration.InitialOffset = CUShort(txtOffset.Text)
        MyConfiguration.Spacing = CUShort(txtSpacing.Text)
        MyConfiguration.BitError = CByte(cb_ECC_BITERR.SelectedIndex + 1)
        Select Case cb_sym_width.SelectedIndex
            Case 0
                MyConfiguration.RsSymSize = 9
            Case 1
                MyConfiguration.RsSymSize = 10
        End Select
        If MyConfiguration.Algorithm = ECC_LIB.ecc_algorithum.dhara OrElse MyConfiguration.Algorithm = ECC_LIB.ecc_algorithum.hamming Then
            If MyConfiguration.ChunkSize > 512 Then
                MyConfiguration.ChunkSize = 512
            End If
        End If
        MyConfiguration.ECC_Reverse = cb_rs_reverse_data.Checked
        Me.Close()
    End Sub

    Private Sub cbAlgorithm_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cbAlgorithm.SelectedIndexChanged
        Select Case cbAlgorithm.SelectedIndex
            Case 0 'Hamming
                cb_sym_width.Enabled = False
                AddBitLevelSupported(1)
                cb_ECC_BITERR.SelectedIndex = 0 'Default 1-bit
            Case 1 'Reed-Solomon
                cb_ECC_BITERR.Enabled = True
                cb_sym_width.Enabled = True
                AddBitLevelSupported(14)
                cb_ECC_BITERR.SelectedIndex = 3 'Default 4-bit
            Case 2 'Binary BCH
                cb_ECC_BITERR.Enabled = True
                cb_sym_width.Enabled = False
                AddBitLevelSupported(26)
                cb_ECC_BITERR.SelectedIndex = 7 'Default 8-bit
            Case 3 'Dhara BCH
                cb_ECC_BITERR.Enabled = True
                cb_sym_width.Enabled = False
                AddBitLevelSupported(4)
                cb_ECC_BITERR.SelectedIndex = 3 'Default 4-bit
        End Select
    End Sub

    Public Sub AddBitLevelSupported(max_supported As Integer)
        cb_ECC_BITERR.Items.Clear()
        For i = 1 To max_supported
            cb_ECC_BITERR.Items.Add(i.ToString() & "-bit")
        Next
    End Sub


End Class