﻿Namespace Global.DoxBoxes

    Public Class Uint16Box
        Inherits TextBox

        Private m_allownull As Boolean = True
        Private m_min As UShort = 0
        Private m_max As UShort = &HFFFF

        Sub New()
            MyBase.New()

        End Sub

        Public Property AllowNull As Boolean
            Get
                Return m_allownull
            End Get
            Set(value As Boolean)
                m_allownull = value
            End Set
        End Property

        Public Property MinValue() As UShort
            Get
                Return m_min
            End Get
            Set(ByVal value As UShort)
                m_min = value
                ProcessCurrentValue()
            End Set
        End Property

        Public Property MaxValue() As UShort
            Get
                Return m_max
            End Get
            Set(ByVal value As UShort)
                m_max = value
                ProcessCurrentValue()
            End Set
        End Property

        Private Sub Uint16Box_KeyDown(sender As Object, e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
            If e.KeyCode = Keys.V AndAlso e.Control Then
                If Clipboard.ContainsText Then
                    Dim cliptext As String = Clipboard.GetText.Trim
                    If Not IsNumeric(cliptext) Then
                        e.Handled = True
                    End If
                Else
                    e.Handled = True
                End If
            End If
        End Sub

        Private Sub Uint16Box_KeyPress(sender As Object, e As System.Windows.Forms.KeyPressEventArgs) Handles Me.KeyPress
            Dim c As Char = e.KeyChar
            Dim i As Integer = Asc(c)
            If IsNumeric(c) Then
            ElseIf i = 8 Then 'backspace
            Else
                e.Handled = True
            End If
        End Sub

        Private Sub Uint16Box_LostFocus(sender As Object, e As System.EventArgs) Handles Me.LostFocus
            ProcessCurrentValue()
        End Sub

        Private Sub ProcessCurrentValue()
            Dim CurrentValue As String = Me.Text.Trim
            If CurrentValue = "" Then
                If Not m_allownull Then
                    Me.Text = m_min.ToString
                End If
            ElseIf IsNumeric(CurrentValue) Then
                Dim l As Long = CLng(CurrentValue)
                If l > m_max Then
                    Me.Text = m_max.ToString
                ElseIf l < m_min Then
                    Me.Text = m_min.ToString
                Else
                    Me.Text = l.ToString
                End If
            Else
                Me.Text = m_min.ToString
            End If

        End Sub

    End Class


End Namespace